<template>
  <div class="flex-grow-1 flex-column" v-bind:class="displayClass">
    <template v-if="loading">
      <div class="d-flex flex-grow-1">
        <div class="mx-auto my-4">
          <h2 class="text-center mt-4">A carregar...</h2>
          <span class="align-middle">
            <clip-loader :loading="loading" color="#007bff" size="50px" radius="100%"></clip-loader>
          </span>
          <div class="mb-4"></div>
        </div>
      </div>
    </template>
    <template v-else-if="error">
      <div class="d-flex flex-grow-1">
        <div class="text-center mx-auto my-4">
          <h1><font-awesome-icon icon="dizzy"></font-awesome-icon></h1>
          <div class="error-message">{{ error }}</div>
        </div>
      </div>
    </template>
    <template v-else>
      <div class="d-flex flex-grow-1 flex-column info-table-container">

        <div class="d-flex flex-row" style="font-size: 0.8em">

          <div class="table-header d-flex flex-column flex-grow-0 bg-light">
            <span class="px-2">Dia</span>
            <span class="px-2">Hora</span>
            <span class="px-2">Temperatura <small>(ºC)</small></span>
            <span class="px-2">Humidade <small>(%)</small></span>
            <span class="px-2">Pressão <small>(hPa)</small></span>
            <span class="px-2">Precipitação <small>(mm)</small></span>
            <span class="px-2">Direção do vento</span>
            <span class="px-2">Int. do vento (km/h)</span>
          </div>

          <div class="d-flex flex-row flex-grow-1 position-relative" style="overflow-x: scroll">
            <div class="d-flex flex-grow-1" style="max-width: 0px">
              <div class="info-table-day d-flex flex-column flex-grow-0 px-1" v-for="day in listDates()" :key="day">
                <div class="info-table-datetime font-weight-bold">
                  {{ day|unixToFormat('YYYY-MM-DD') }}
                </div>
                <div class="day-items d-flex flex-row flex-grow-0">
                  <div class="info-table-item d-flex flex-column flex-grow-0 px-1" v-for="hour in listHoursForDay(day)" :key="hour">
                    <span class="font-weight-bold">{{ hour|unixToFormat('HH[h]') }}</span>
                    <span class="flex-grow-1">
                      {{ getDataForDateTime('ecmwf.temperature.atlantic', hour) | format }}
                    </span>
                    <span class="flex-grow-1">
                      {{ getDataForDateTime('ecmwf.relative_humidity.atlantic', hour) | format}}
                    </span>
                    <span class="flex-grow-1">
                      {{ getDataForDateTime('ecmwf.pressure.atlantic', hour) | pressure }}
                    </span>
                    <span class="flex-grow-1">
                      {{ getDataForDateTime('ecmwf.precipitation.atlantic', hour) | format }}
                    </span>
                    <span class="flex-grow-1">
                      <font-awesome-icon :icon="getWindDirForDateTime(hour)"></font-awesome-icon>
                    </span>
                    <span class="flex-grow-1">
                      {{ getWindSpeedForDateTime(hour) | kmh }}
                    </span>
                  </div>
                </div>
              </div>
            </div>
          </div>

        </div>

      </div>
      <div class="model-selector d-flex flex-grow-0 flex-row mx-1 my-2">
        <div class="btn-group btn-group-toggle" data-toggle="buttons">
          <label class="btn btn-primary btn-sm active">
            <input type="radio" name="options" id="option1" checked>
            ECMWF
          </label>
          <label class="btn btn-light btn-sm">
            <input type="radio" name="options" id="option1" checked>
            AROME
          </label>
        </div>
      </div>
    </template>
  </div>
</template>

<script>
// Vendor
import moment from 'moment'
import { Util } from 'leaflet'

// Mixins
import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'
import MomentMixin from '@/core/mixins/moment'

// Utilities
import { findParentComponentByName } from '@/core/util'
import { getModelsForPoint } from '@/core/forecast'

import { queryBuilder } from '@/core/query/query'
import { generateTimeList } from '@/core/query/utils'

// Components
import ClipLoader from 'vue-spinner/src/ClipLoader'


export default {
  name: 'infotable',

  mixins: [
    ParentWorkspaceMixin,
    MomentMixin,
  ],

  props: {
    name: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      loading: true,
      error: null,
      queryData: {},
    }
  },

  filters: {
    format: function(value) {
      return value !== null ? Util.formatNum(value, 1) : null
    },

    temperature: function(value) {
      return value !== null ? Util.formatNum(value - 273.5, 1) : null
    },

    pressure: function(value) {
      return value !== null ? Util.formatNum(value / 100, 1) : null
    },

    kmh: function(value) {
      return value !== null ? Util.formatNum(value * 3.6, 1) : null
    },
  },

  computed: {
    queryPanel: {
      get() {
        return findParentComponentByName(this.$parent, 'querypanel')
      }
    },

    query: {
      get() {
        return this.$store.state[this.workspace].query
      },
    },

    queryPoint: {
      get() {
        return this.query ? this.$store.getters.getLocationById(this.query.id) : null
      },
    },

    referenceTime: {
      get() {
        return this.$store.state[this.workspace].referenceTime
      },
    },

    displayClass: {
      get() {
        return this.queryPanel.currentPanel === this.name ? 'd-flex' : 'd-none'
      },
    },
  },

  watch: {
    queryPoint(after) {
      if(after !== null) this.get()
    },
  },

  methods: {
    get() {
      // Generate the list of queries to be made to the server
      let queryList = [
        queryBuilder('ecmwf.temperature.atlantic'),
        queryBuilder('ecmwf.relative_humidity.atlantic'),
        //queryBuilder('ecmwf.precipitation.atlantic'),
        queryBuilder('ecmwf.pressure.atlantic'),
        queryBuilder('ecmwf.wind_u.atlantic'),
        queryBuilder('ecmwf.wind_v.atlantic'),
      ].map((item) => {
        return item.setLatitude(this.queryPoint.latitude)
          .setLongitude(this.queryPoint.longitude)
          .setReferenceTime(moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:mm:00[Z]'))
          .setTime(generateTimeList(this.referenceTime, 48))
          .execute()
      })

      // Wait for all queries and process the data
      Promise.all(queryList).then((responses) => {
        responses.forEach((response) => {
          Util.extend(this.queryData, response.data.properties)
        })

        this.loading = false
      }).catch(() => {
        this.error = "Ocorreu um erro ao descarregar os dados"
        this.loading = false
      })
    },

    listDates() {
      return [0, 1].map((i) => { return moment.unix(this.referenceTime).clone().add(i, 'days').unix() })
    },

    listHoursForDay(day) {
      return [...Array(24).keys()].map((i) => { return moment.unix(day).clone().add(i, 'hour').unix() })
    },

    getDataForDateTime(name, dateTime) {
      if(name === 'ecmwf.precipitation.atlantic') return 0
      let stamp = moment.unix(dateTime).format('YYYY-MM-DDTHH:00:00')
      let value = this.queryData[name].find(element => element.time === stamp && element.level === 'surface')
      return value ? Util.formatNum(value.value, 4) : null
    },

    getWindSpeedForDateTime(dateTime) {
      let stamp = moment.unix(dateTime).format('YYYY-MM-DDTHH:00:00')
      let value_u = this.queryData['ecmwf.wind_u.atlantic'].find(element => element.time === stamp && element.level === 'surface')
      let value_v = this.queryData['ecmwf.wind_v.atlantic'].find(element => element.time === stamp && element.level === 'surface')
      window.console.log(value_u, value_v)
      if(value_u && value_v) {
        return Util.formatNum(Math.sqrt(value_u.value * value_u.value + value_v.value * value_v.value), 1)
      }

      return null
    },

    getWindDirForDateTime(dateTime) {
      let stamp = moment.unix(dateTime).format('YYYY-MM-DDTHH:00:00')
      let value_u = this.queryData['ecmwf.wind_u.atlantic'].find(element => element.time === stamp && element.level === 'surface')
      let value_v = this.queryData['ecmwf.wind_v.atlantic'].find(element => element.time === stamp && element.level === 'surface')
      if(value_u && value_v) {
        return 'arrow-right'
      }

      return 'arrow-right'
    },

    listModels() {
      if(this.query === null) return []
      return getModelsForPoint([this.queryPoint.latitude, this.queryPoint.longitude])
    },
  },

  mounted() {
    //this.get()
  },

  components: {
    ClipLoader,
  },
}
</script>

<style scoped>
.day-items:nth-child(even) {
  background-color: #f8f9fa !important
}

.info-table-item {
  min-width: 40px;
}

.table-header span,
.info-table-datetime,
.info-table-item span {
  min-height: 20px;
}

.info-table-day {
  border-left: 1px solid #9b9b9b;
}

.error-message {
  margin-top: 1rem;
  padding-top: 1rem;
  border-top: darkgrey solid 1px;
}

.model-selector label {
  font-size: 0.5rem;
}
</style>
